/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.12E */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "abimport.h"
#include "proto.h"

int finished, flag, flag2, next, move, moves[3][3];
extern int first, PlayerO, PlayerX;


int
oxo( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{

	int widget_name;
	
	widget_name=ApName(widget);
	
	if(widget_name==ABN_NewGame)
			NewGame();
	
	if (finished!=1)
		{

		flag=0;
		if(next==0)
			next=first;
	
		if (next==1)
			{
			if (PlayerO==0)
				flag=1;
			if (PlayerO==1)
				flag=0;
			}
		
		if (next==-1)
			{
			if (PlayerX==0)
				flag=1;
			if (PlayerX==1)
				flag=0;
			}
	
		if (flag==0)
			{

			if(widget==ABW_TL)
				if(moves[0][0]==0)
					{
					moves[0][0]=next;
					next=(-next);
					}

			if(widget==ABW_TC)
				if(moves[0][1]==0)
					{
					moves[0][1]=next;
					next=(-next);
					}

			if(widget==ABW_TR)
				if(moves[0][2]==0)
					{
					moves[0][2]=next;
					next=(-next);
					}
	
			if(widget==ABW_ML)
				if(moves[1][0]==0)
					{
					moves[1][0]=next;
					next=(-next);
					}
	
			if(widget==ABW_MC)
				if(moves[1][1]==0)
					{
					moves[1][1]=next;
					next=(-next);
					}
	
			if(widget==ABW_MR)
				if(moves[1][2]==0)
					{
					moves[1][2]=next;
					next=(-next);
					}
	
			if(widget==ABW_BL)
				if(moves[2][0]==0)
					{
					moves[2][0]=next;
					next=(-next);
					}
	
			if(widget==ABW_BC)
				if(moves[2][1]==0)
					{
					moves[2][1]=next;
					next=(-next);
					}
	
			if(widget==ABW_BR)
				if(moves[2][2]==0)
					{
					moves[2][2]=next;
					next=(-next);
					}
	
			}		
		
		if (flag==1)
			Compmove();
	
		Redraw();
		Check();
		ToPlay();
		}
	
	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;
	
	return( Pt_CONTINUE );
	}

void NewGame()
	{
	int x, y;
	finished=0;

	for (x=0; x<3; x++)
		for (y=0; y<3; y++)
			moves[x][y]=0;

	next=first;
	flag=2;
	}
		
void Compmove()
	{
	int sum, x, y, flag3;
	flag3=0;
	sum=0;
	x=0;
	y=0;
	flag2=0;
	
	for (x=0; x<3; x++)
		{
		sum=0;
		for (y=0; y<3; y++)
			{
			sum+=moves[x][y];
			if (abs(sum)==2) 
				{ 
				for (y=0; y<3; y++) 
				if (moves[x][y]==0) 
					{ 
					moves[x][y]=next;
					y=3; x=3; flag2=1; 
					}
				}
			}
		}

	if (flag2==0)
		for (y=0; y<3; y++)
			{
			sum=0;
			for (x=0; x<3; x++)
				sum+=moves[x][y];
		
			if (abs(sum)==2) 
				{
				for (x=0; x<3; x++)
					if (moves[x][y]==0)
						{
						moves[x][y]=next;
						x=3;
						y=3;
						flag2=1;
						}

				}
			}
		
	if (flag2==0)
		{
		sum=0;
		sum+=moves[0][0];
		sum+=moves[1][1];
		sum+=moves[2][2];
		if (abs(sum)==2)
			for (x=0; x<3; x++)
				{
				y=x;
				if (moves[x][y]==0)
					{
					moves[x][y]=next;
					x=3;
					flag2=1;
					}
				}
		}

	if (flag2==0)
		{
		sum=0;
		sum+=moves[0][2];
		sum+=moves[1][1];
		sum+=moves[2][0];
		if(abs(sum)==2) 
			{
			if(moves[0][2]==0)
				{
				moves[0][2]=next;
				flag3=1;
				}
			if((moves[1][1]==0) && (flag3==0))
				{
				moves[1][1]=next;
				flag3=1;
				}
			if((moves[2][0]==0) && (flag3==0))
				{
				moves[2][0]=next;
				flag3=1;
				}
			flag2=1;
			}

		}

	if (flag2==0)
		if (moves[1][1]==0)
			{
			moves[1][1]=next;
			flag2=1;
			}

	if (flag2==0)
		for (x=0; x<3; x++)
			for (y=0; y<3; y++)
				if (moves[x][y]==0)
					{
					moves[x][y]=next;
					y=3;
					x=3;
					}
	next=(-next);
	}

void Redraw()
	{
	PtArg_t args[3];
	extern ApBitmap_t *image[3];

	PtSetArg(&args[0],Pt_ARG_BITMAP_DATA, image[0]->data,0);
	PtSetArg(&args[1],Pt_ARG_BITMAP_DATA, image[1]->data,0);
	PtSetArg(&args[2],Pt_ARG_BITMAP_DATA, image[2]->data,0);



	if(moves[0][0]==-1)
		PtSetResources(ABW_TL, 1, &args[0]);
	
	if(moves[0][0]==1)
		PtSetResources(ABW_TL, 1, &args[1]);

	if(moves[0][0]==0)
		PtSetResources(ABW_TL, 1, &args[2]);


	
	if(moves[0][1]==-1)
		PtSetResources(ABW_TC, 1, &args[0]);
	
	if(moves[0][1]==1)
		PtSetResources(ABW_TC, 1, &args[1]);

	if(moves[0][1]==0)
		PtSetResources(ABW_TC, 1, &args[2]);
	
	

	if(moves[0][2]==-1)
		PtSetResources(ABW_TR, 1, &args[0]);
		
	if(moves[0][2]==1)
		PtSetResources(ABW_TR, 1, &args[1]);
	
	if(moves[0][2]==0)
		PtSetResources(ABW_TR, 1, &args[2]);

	

	if(moves[1][0]==-1)
		PtSetResources(ABW_ML, 1, &args[0]);
	
	if(moves[1][0]==1)
		PtSetResources(ABW_ML, 1, &args[1]);

	if(moves[1][0]==0)
		PtSetResources(ABW_ML, 1, &args[2]);


	
	if(moves[1][1]==-1)
		PtSetResources(ABW_MC, 1, &args[0]);
	
	if(moves[1][1]==1)
		PtSetResources(ABW_MC, 1, &args[1]);

	if(moves[1][1]==0)
		PtSetResources(ABW_MC, 1, &args[2]);


	
	if(moves[1][2]==-1)
		PtSetResources(ABW_MR, 1, &args[0]);
	
	if(moves[1][2]==1)
		PtSetResources(ABW_MR, 1, &args[1]);
	
	if(moves[1][2]==0)
		PtSetResources(ABW_MR, 1, &args[2]);



	if(moves[2][0]==-1)
		PtSetResources(ABW_BL, 1, &args[0]);

	if(moves[2][0]==1)
		PtSetResources(ABW_BL, 1, &args[1]);
	
	if(moves[2][0]==0)
		PtSetResources(ABW_BL, 1, &args[2]);
	


	if(moves[2][1]==-1)
		PtSetResources(ABW_BC, 1, &args[0]);
	
	if(moves[2][1]==1)
		PtSetResources(ABW_BC, 1, &args[1]);
	
	if(moves[2][1]==0)
		PtSetResources(ABW_BC, 1, &args[2]);



	if(moves[2][2]==-1)
		PtSetResources(ABW_BR, 1, &args[0]);
	
	if(moves[2][2]==1)
		PtSetResources(ABW_BR, 1, &args[1]);
	
	if(moves[2][2]==0)
		PtSetResources(ABW_BR, 1, &args[2]);

	}

void Check()
	{
	int sum, x, y;
	sum=0;

	for (x=0; x<3; x++)
		{
		sum=0;
		for (y=0; y<3; y++)
			{
			sum+=moves[x][y];
			if (abs(sum)==3)
			finished=1;
			}
		}
	sum=0;

	for (y=0; y<3; y++)
		{
		sum=0;
		for (x=0; x<3; x++)
			{
			sum+=moves[x][y];
			if (abs(sum)==3)
			finished=1;
			}
		}
	sum=0;

	sum=((moves[0][0])+(moves[1][1])+(moves[2][2]));
	if (abs(sum)==3)
		finished=1;

	sum=0;

	sum=((moves[2][0])+(moves[1][1])+(moves[0][2]));
	if (abs(sum)==3)
		finished=1;
	
	if (finished==1)
		{
		ApCreateModule(ABM_Winner, NULL, NULL);
		winner();
		}
	}

void ToPlay()
	{
	char text_string[3];
	PtArg_t textargs[1];
	strcpy(text_string, "DOG");
	if (next==-1)
		strcpy(text_string, "CAT");

	PtSetArg( &textargs[0], Pt_ARG_TEXT_STRING, &text_string, 0);
	PtSetResources(ABW_ToPlay, 1, &textargs);
	}

void winner()
	{
	char text_string[3];
	PtArg_t textargs[1];
	strcpy(text_string, "CAT");
	if (next==-1)
		strcpy(text_string, "DOG");

	PtSetArg( &textargs[0], Pt_ARG_TEXT_STRING, &text_string, 0);
	PtSetResources(ABW_Who, 1, &textargs);
	}