/* Event header for application - AppBuilder 1.12E */

const ApEventLink_t appl_links[] = {
	{ 3, 0, 0L, 0L, 0L, &base, base_links, NULL, 0, set, 0, 9, 0, 0, dsbase },
	{ 0, 0, 0L, 0L, 0L, NULL, NULL, NULL, 0, NULL, 0, 0, 0, 0, NULL }
	};

ApEventLink_t internal_links[] = {
	{ 4, 0, 0L, 0L, 0L, &Winner, Winner_links, NULL, 0, NULL, 0, 9, 0, 0, dsWinner },
	{ 11, 0, 0L, 0L, 0L, &DB, DB_links, NULL, 0, NULL, 0, 0, 0, 0, dsDB },
	{ 0, 0, 0L, 0L, 0L, NULL, NULL, NULL, 0, NULL, 0, 0, 0, 0, NULL }
	};

const ApEventLink_t base_links[] = {
	{ 5, 0, 0L, 0L, 0L, &GameMenu, GameMenu_links, "Game", 2009, NULL, 0, 1, 0, 0, NULL },
	{ 5, 0, 0L, 0L, 0L, &OptionMenu, OptionMenu_links, "Options", 2009, NULL, 0, 1, 0, 0, NULL },
	{ 5, 0, 0L, 0L, 0L, &HelpMenu, HelpMenu_links, "Help", 2009, NULL, 0, 1, 0, 0, NULL },
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "TC", 2009, oxo, 0, 0, 0, 0, NULL },
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "TR", 2009, oxo, 0, 0, 0, 0, NULL },
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "ML", 2009, oxo, 0, 0, 0, 0, NULL },
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "MC", 2009, oxo, 0, 0, 0, 0, NULL },
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "MR", 2009, oxo, 0, 0, 0, 0, NULL },
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "BL", 2009, oxo, 0, 0, 0, 0, NULL },
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "BC", 2009, oxo, 0, 0, 0, 0, NULL },
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "BR", 2009, oxo, 0, 0, 0, 0, NULL },
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "TL", 2009, oxo, 0, 0, 0, 0, NULL },
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "Timer", 41002, oxo, 0, 0, 0, 0, NULL },
	{ 0, 0, 0L, 0L, 0L, NULL, NULL, NULL, 0, NULL, 0, 0, 0, 0, NULL }
	};

const ApEventLink_t AboutOXO_links[] = {
	{ 9, 0, 0L, 0L, 0L, NULL, NULL, "OXOBit", 2009, NULL, 0, 0, 0, 0, NULL },
	{ 0, 0, 0L, 0L, 0L, NULL, NULL, NULL, 0, NULL, 0, 0, 0, 0, NULL }
	};

const ApEventLink_t DB_links[] = {
	{ 0, 0, 0L, 0L, 0L, NULL, NULL, NULL, 0, NULL, 0, 0, 0, 0, NULL }
	};

const ApEventLink_t GameMenu_links[] = {
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "NewGame", 2009, oxo, 0, 0, 0, 0, NULL },
	{ 9, 0, 0L, 0L, 0L, NULL, NULL, "QuitGame", 2009, NULL, 0, 0, 0, 0, NULL },
	{ 0, 0, 0L, 0L, 0L, NULL, NULL, NULL, 0, NULL, 0, 0, 0, 0, NULL }
	};

const ApEventLink_t HelpMenu_links[] = {
	{ 4, 0, 0L, 0L, 0L, &AboutOXO, AboutOXO_links, "About", 2009, NULL, 0, 0, 0, 0, dsAboutOXO },
	{ 0, 0, 0L, 0L, 0L, NULL, NULL, NULL, 0, NULL, 0, 0, 0, 0, NULL }
	};

const ApEventLink_t OptionMenu_links[] = {
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "P1C", 2009, setup, 0, 0, 0, 0, NULL },
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "P1H", 2009, setup, 0, 0, 0, 0, NULL },
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "P2C", 2009, setup, 0, 0, 0, 0, NULL },
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "P2H", 2009, setup, 0, 0, 0, 0, NULL },
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "OTS", 2009, setup, 0, 0, 0, 0, NULL },
	{ 8, 0, 0L, 0L, 0L, NULL, NULL, "XTS", 2009, setup, 0, 0, 0, 0, NULL },
	{ 0, 0, 0L, 0L, 0L, NULL, NULL, NULL, 0, NULL, 0, 0, 0, 0, NULL }
	};

const ApEventLink_t Winner_links[] = {
	{ 9, 0, 0L, 0L, 0L, NULL, NULL, "wintext", 2009, NULL, 0, 0, 0, 0, NULL },
	{ 9, 0, 0L, 0L, 0L, NULL, NULL, "Who", 2009, NULL, 0, 0, 0, 0, NULL },
	{ 9, 0, 0L, 0L, 0L, NULL, NULL, "Text", 2009, NULL, 0, 0, 0, 0, NULL },
	{ 0, 0, 0L, 0L, 0L, NULL, NULL, NULL, 0, NULL, 0, 0, 0, 0, NULL }
	};

const char ApOptions[] = AB_OPTIONS;
